﻿/*
File	vpro01.js
Date	2017-08-07
Revision history
 2018-01-14	
	* syntax error in font_egala()
	* convert 'mojiretu' to lowercase in romaji_seiri()
*/

window.onload= function() {

	var s_time=new Date();

	if ((DiskInit=="2")||(DiskNumber=="")){
		alert("インストール(初期化)してから実行してください");
		window.open("about:blank", "_self").close();
		}
		else{
			DiskInit=DiskInit.replace(/ /g, "");
			if ((DiskInit!=true)&&(DiskInit.length!=20)){
				alert("辞書キーが間違っています");
				window.open("about:blank", "_self").close();			
				}
				else{
				document.getElementById("searchstr").focus();			
				}
		}

	
	font_egala();

	if ( g_inigamen=="Y" ) {
		showSearchPane();
	}

	gWD_settei();
	imageShow();

	addEventHandler(document.getElementById("pageimg"), "mousedown", Img_OnMouse_down);
	addEventHandler(document.getElementById("pageimg"), "mousemove", Img_OnMouse_move);
	addEventHandler(document.getElementById("results"), "click", showArticle);
	addEventHandler(document.getElementById("searchstr"), "keypress", inputSearchStr);
	addEventHandler(document.getElementById("page"), "keypress", inputPagePress);

	var imgs=document.getElementsByTagName("img");

	for (var i=0; i<imgs.length; ++i) {
		if (imgs[i].className=="button") {
			addEventHandler(imgs[i], "mouseover", showTip);
			addEventHandler(imgs[i], "mouseout", hideTip);
		}
	}
	var inistr=document.getElementById("searchstr").value;
	if (inistr.length > 0) {
		inputSearchStr();
	}

	setPagingClickRange();

	if (vortaro_modifi()!=true){
		alert("辞書の修正処理が正常に実行できませんでした");
	}

	var initv="";

	DiskInit=DiskInit.replace(/ /g, "");
	if ((DiskInit!="1")&&(DiskInit.length==20)){ 

	var novakey14=DiskInit.substring(0,14);	

	var novk=MD5_hexhash(novakey14);

	initv= rc4_init(novk);

    //decrypt(initv);
	}	

	var Vmax=vortaro.length;
	if (pub_mez<Vmax){
		kigooka_shori(initv);
	}
	var error="";	
	var w_time=new Date();	
	pub_keika=w_time - s_time;
	if (pub_mez<Vmax){
		error="E";
		alert("解読未完了 " + pub_mez + " 件済み " + pub_keika + " ミリ秒");
	}

if (error!=""){alert("解読処理などが正常に実行できませんでした");}

	

}

function gWD_settei() {
    var Av_name = document.getElementById("vort_namae").innerHTML;
	Av_name = Av_name.replace("<b>","%");
	var Av_name1 = Av_name.split("%");
	Av_name = Av_name1[1];
    gWD         = "";
    Page_max    = Page_max_WD[0];
    PageWidth   = PageWidth_WD[0];
    PageHeight  = PageHeight_WD[0];

    if (Av_name[0]=="D") {
        gWD="D";
        Page_max=Page_max_WD[1];
        PageWidth=PageWidth_WD[1];
        PageHeight=PageHeight_WD[1];
        }

}

function showArticle(event) {

	var target;
	if (window.event)
		target= window.event.srcElement;
		else
		target= event.target;

	var page= target.getAttribute("params");//0001L-1073R
	var pos= page.length-1;
	var pageLR= page.substring(pos);
	var pagex = page.substring(0, pos);

	setPage(pagex);
	setPageLR(pageLR);

	src= pageImgFilename(pagex, pageLR);

	var img=document.getElementById("pageimg");
	img.src= src;
	if (!pageShown) {
		pageShown=true;
		scale();
	}
	imageOnShow();
}

function formatNumb(numb, digits) {
	return fillZeros(numb.toString(), digits);
}

function fillZeros(str, digits) {
	while (str.length<digits) {
		str= "0"+str;
	}
	return str;	
}

function removeZeros(str) {
	str=str+"";//こうしないとエラーの場合があった？
	while (str.charAt(0)=='0') {
		str= str.substring(1);
	}
	return str;
}

function showOptions() {
	var panel=document.getElementById("optionpanel");
	var button=document.getElementById("enableoptions");
	var results=document.getElementById("results");
	if (panel.style.display=="none") {
		panel.style.display="block";
	}
	else {
		panel.style.display="none";
	}
}

function convSpChars(str, useOR, useWildcard) {
	str= str.replace(/\\/g, "\\\\");
	str= str.replace(/\(/g, "\\(");
	str= str.replace(/\)/g, "\\)");
	str= str.replace(/\[/g, "\\[");
	str= str.replace(/\{/g, "\\{");
	str= str.replace(/\^/g, "\\^");
	str= str.replace(/\$/g, "\\$");
	str= str.replace(/\?/g, "\\?");
	str= str.replace(/\./g, "\\.");

	if (useOR)
		str=str.replace(/\|/g, "|");
	else
		str= str.replace(/\|/g, "\\|");

	if (useWildcard)
		str= str.replace(/\*/g, ".*");
	else
		str= str.replace(/\*/g, "\\*");
	return str;
}

function andsearch(ands, str) {
	var i;
	for (i=0; i<ands.length; ++i) {
		if (!ands[i].test(str))
			return false;
	}
	return true;
}

function makeResult(klass, page, line) {
	var div= document.createElement("div");
	div.className=klass;
	div.setAttribute("params", page);
	var txt= document.createTextNode(line);
	div.appendChild(txt);
	return div;
}

function getText(elem) {
	var ch=elem.firstChild;
	while (ch) {
		if (ch.nodeType==3)
			return ch.nodeValue;
		ch=ch.nextSibling;
	}
	return "(none)";
}

function setText(elem, text) {
	elem.innerHTML=text;
}

function isIE() {
	return (navigator.userAgent.indexOf("MSIE") >= 0);
}

function addEventHandler(elem, evtname, handler) {
	if (isIE())
		elem.attachEvent("on"+evtname, handler);
	else
		elem.addEventListener(evtname, handler, false);
}

function removeEventHandler(elem, evtname, handler) {
	if (isIE())
		elem.detachEvent(evtname, handler);
	else
		elem.removeEventListener(evtname, handler, false);
}

function xnotation(key, str) {
	if (str.length<1)
		return 'x';
	var last= str[str.length-1];
    var pre_str="";
    if (str.length>1){
        pre_str=str.substring(0,str.length-1);
    }
	var c=last;
	switch(last) {
		case 'c':
			c='ĉ'; break;
		case 'g':
			c='ĝ'; break;
		case 'h':
			c='ĥ'; break;
		case 'j':
			c='ĵ'; break;
		case 's':
			c='ŝ'; break;
		case 'u':
			c='ŭ'; break;
		case 'C':
			c='Ĉ'; break;
		case 'G':
			c='Ĝ'; break;
		case 'H':
			c='Ĥ'; break;
		case 'J':
			c='Ĵ'; break;
		case 'S':
			c='Ŝ'; break;
		case 'U':
			c='Ŭ'; break;

	}

    var out=pre_str;
    if ( (c=="+") || (c=="x") || (c=="X") ){c="";last="";}
    if (c==last)  {
        if (key==88){c=c+"X"}
        if (key==120){c=c+"x"}
    }

	return pre_str+c;
}

function inputSearchStr(e) {

	var schstr= document.getElementById("searchstr").value;
	var evt;

	if (window.event) {
		evt= window.event;
	}
	else {
		evt= e;
	}
	var key= evt.keyCode;
	if (!key) {key= evt.charCode;}	//for Firefox
	if (isIE()) {
		evt.returnValue=false;
		evt.cancelBubble=true;
		}
	else {
		evt.preventDefault();
		evt.stopPropagation();
		}

	if ( ( key==88 )  || ( key==120 ) ) {

		var keystr=String.fromCharCode(key);
		if (schstr=="") {schstr=keystr;}
		schstr=xnotation(key, schstr);

	}
	else
		

	if ( ( ( key>96 ) && ( key<123 ) ) || ( key==32 ) ||
	     ( ( key>64 ) && ( key<91  ) ) || ( key==33 ) ||
	     ( key==34 )  || ( key==38 )  || ( key==39 ) ||
	     ( key==42 )  || ( key==43 )  || ( key==45 ) ||		 
	     ( key==63 )   || ( key==124 ) ) {
		var keystr=String.fromCharCode(key);
		schstr=schstr+keystr;

	}
	else

	if ( ( key==8 ) || ( key==46 ) ) {

		intstr="";
		if ( schstr.length > 1) {
			schstr=schstr.substring(0,schstr.length-1);}
		else { schstr=""; }
		document.getElementById("searchstr").value=schstr;
		}

		document.getElementById("searchstr").value=schstr;

	if ( key==13 ) {
			search();
	}

}

function inputIssue(e) {
	var evt;
	if (window.event)
		evt= window.event;
	else
		evt= e;
	var key= evt.keyCode;
	if (!key)
		key= evt.charCode;	//for Firefox

	if (key==13) {
		if (isIE()) {
			evt.returnValue=false;
			evt.cancelBubble=true;
		}
		else {
			evt.preventDefault();
			evt.stopPropagation();
		}

		showContent();
	}
	var elem= document.getElementById("yearmonth");
	var val= elem.value;

	if (key!=8) {
		if (val.match(/^\d{6}$/) || val.match(/^(\d{4})\D{1}(\d{2})\D*/)) {
			showContent();
		}
	}
}

var tips= {
	"btnshowsearchpane":"目次・検索一覧表を表示/非表示",
	"firstpage":"第一ページ",
	"prevpage":"前ページ",
	"nextpage":"次ページ",
	"lastpage":"最終ページ",
	"zoomout":"画像縮小",
	"zoom1":"画像等倍",
	"zoomin":"画像拡大",
	"klarigo":"使用方法を表示",
	"font_mal":"文字を縮小する",
	"font_egl":"文字を既定値にする",
	"font_grd":"文字を拡大する",
	"imgrefine":"&amp; で「かつ」を表します<br>&amp;は何個でも追加できます<br>(&amp;の前後に空白を入れても構いません)<br>例: 大会 &amp; 大阪",
	"imgOR":"| (縦線)で「または」を表します<br>(| の前後に空白を入れても構いません)<br>例: 大阪 | 京都<br>| は &amp; より優先順位が高くなります<br>例: 大阪|京都 &amp; 大会 (「大阪または京都」かつ「大会」を含む)",
	"imgWildcard":"* で任意の文字列にマッチします<br>例: 国際*大会 (「国際」の後ろのどこかに「大会」)",
	"imgEkzemplo":"ここにチェックが無ければ、<br>一つの例文でも検索文字が見つかれば、<br>その単語の全部の内容(説明と例文等)が表示されます。<br>チェックを入れると、見出しのある最初の行と、<br>見つかった例文等のみ表示します"

};

function showTip() {
	var evt;
	if (window.event)
		evt=window.event;
	else
		evt=arguments[0];

	var targetId= (isIE()? evt.srcElement: evt.target).id;
	var tip= tips[targetId];
	if (tip) {
		var elem=document.getElementById("tip");
		elem.style.left= (evt.clientX)+"px";
		elem.style.top= (evt.clientY+20)+"px";
		setText(elem, tip);
		elem.style.display="inline";
	}
}
function hideTip() {
	document.getElementById("tip").style.display="none";
}

var timer;
var timecount;
function showMessageBox(msg) {
	var msgtext= document.getElementById("msgtext");
	msgtext.innerHTML=msg;

	var elem= document.getElementById("messagebox");
	elem.style.opacity="1.0";
	elem.style.filter="alpha(opacity=100)";
	elem.style.display="block";
	timecount=50;
	timer= setTimeout("blurMsgbox()", 100);
}

function closeMessageBox() {
	document.getElementById("messagebox").style.display="none";
	clearTimeout(timer);
}
function blurMsgbox() {
	--timecount;
	if (timecount==0) {
		closeMessageBox();
		return;
	}
	else if (timecount<=25) {
		var elem=document.getElementById("messagebox");
		elem.style.opacity=(timecount/25.0);
		var n= 100*timecount/25;
		elem.style.filter="alpha(opacity="+n+")";
	}
	timer= setTimeout("blurMsgbox()", 100);
}

function font_granda() {
	changeFontSize(1);
}
function font_egala() {
	document.body.style.fontSize=StdFontSize+"pt";
}
function font_malgranda() {
	changeFontSize(-1);
}
function changeFontSize(incr) {
	var strsize= document.body.style.fontSize;
	var m= strsize.match(/(\d+)/);
	if (!m)
		return;
	var newsize= parseInt(m[1]) + incr;
	if (newsize<MinFontSize || newsize>MaxFontSize) {
		showMessageBox("これ以上大きく/小さくできません。<br>(有効範囲: "+
MinFontSize+"～"+MaxFontSize+"pt)");
		return;
	}
	document.body.style.fontSize= newsize+"pt";
}

function pageImgFilename(page, pageLR) {
	if (page==0) { page=1;pageLR="L"; }
	page=formatNumb(page, 4);
	var dir_nam=gWD + gVN + "_img"  + "/";

	var page_img_nomo = gWD + gVN;

	if (gWD=="D") {
		page=page + pageLR;
		}
	img_namae = dir_nam + page_img_nomo + page + ".gif";

	return img_namae;
}

function getPage() {
	var elem=document.getElementById("page");
	var v=removeZeros(elem.value);
	if (v.length==0) {
		v="1";
	}
	elem.value=v;
	return v;
}

function setPage(page) {

	document.getElementById("page").value=page;
}

function setPageLR(lr) {
	document.getElementById("pLR").value= lr;
}

function showPageImg() {
	showPage(0);
}

function showPage(xxx) {

	var elem=document.getElementById("page");
	var val=elem.value;
	val=removeZeros(val);

	var pageLR="";
	if (gWD=="D")
		pageLR= document.getElementById("pLR").value;

	var page=0;
	if (val) {page=parseInt(val);}
	if (gWD!="D"){page=page+xxx;}
	else {
		if (xxx==1) {
			if (pageLR=="R") {++page; pageLR="L";}
			else {pageLR="R";}
		}
		else if (xxx==-1) {
			if (pageLR=="L") {--page; pageLR="R";}
			else {pageLR="L";}
		}
	}
	if (page<Page_start)
		{page=Page_start; pageLR="L";}
	if (page>Page_max) {
		showMessageBox("最終頁は " + Page_max + " です");
		page=Page_max; pageLR="R";
	}
	var page_str=fillZeros(page.toString(),4);

	setPage(page_str);
	if (gWD=="D") {
		setPageLR(pageLR);
	}
	var src= pageImgFilename(page_str, pageLR);
	var img=document.getElementById("pageimg");

	img.src= src;
	if (!pageShown) {
		pageShown=true;
		scale();
	}
}

function showPrevPage() {
	showPage(-1);
}

function showNextPage() {
	showPage(+1);
}

var curScale=gcurScale;

function scale() {
	if (!pageShown)
		return;
	var width= Math.floor(PageWidth*curScale/100);
	var height= Math.floor(PageHeight*curScale/100);
	var elem=document.getElementById("pageimg");
	elem.setAttribute("width", width+"px");
	elem.setAttribute("height",height+"px");

	setPagingClickRange();

}

function enlarge() {
	curScale *= 1.1;
	scale();
}

function scale100() {
	var elem=document.getElementById("pageimg");
	curScale= gcurScale;
	scale();
}

function shrink() {
	curScale /= 1.1;
	scale();
}

function inputPagePress(e) {
	var evt;
	if (window.event)
		evt= window.event;
	else
		evt= e;
	var key= evt.keyCode;
	if (!key)
		key= evt.charCode;	//for Firefox

	if (key==13) {
		if (isIE()) {
			evt.returnValue=false;
			evt.cancelBubble=true;
		}
		else {
			evt.preventDefault();
			evt.stopPropagation();
		}
		//
		var elem=document.getElementById("page");
		var val=elem.value;
		var ppp=val.match(/^\d{1,3}$/);
		if (!ppp) {
			return;
		}

		if (ppp=="0" || ppp=="")
			ppp="1";
		setPage(ppp);
		showPage(0);
	}

	if (key!=8) {
		var elem=document.getElementById("page");
		var val=elem.value;

		if ( key>47 && key<58) {
			key=key-48;
			val=val + key.toString();
		}
		var ppp=val.match(/^\d{4}$/);
		if (!ppp) {
			return;
		}
    	var page_aa=removeZeros(ppp);

    	var page_nn=parseInt(page_aa);
		if ( page_nn>Page_start-1 && page_nn<(Page_max+1) ) {
			setPage(ppp);
			showPage(0);
		}
		else {
			showMessageBox("頁範囲は "+Page_start +  "～" + Page_max+" です");
    		if ( page_nn<Page_start ) {
	    		setPage(Page_start);
		    	showPage(0);
		    }
		    if ( page_nn>Page_max ) {
			    setPage(Page_max);
			    showPage(0);
		    }
		}
	}
}

function showSearchPane() {// ▲一覧出す　△一覧隠す
	var leftPane=document.getElementById("results");
	var rightPane=document.getElementById("imagepane");
	var fontBT=document.getElementById("font_buttons");
	if (leftPane.style.display=="none") {
		img_only="N";
		leftPane.style.width="150px";
		leftPane.style.display="block";
		rightPane.style.left="162px";
		setText(document.getElementById("btnshowsearchpane"), "▲一覧隠す");
		fontBT.style.display="inline";
	}
	else {
		img_only="Y";

		leftPane.style.display="none";
		rightPane.style.left="5px";
		setText(document.getElementById("btnshowsearchpane"), "△一覧出す");
		fontBT.style.display="none";
	}
	setPagingClickRange();
}

function imageShow() {
	var MD_result=document.getElementById("results");
	var KR_result=document.getElementById("klarigoj_results");
	var ImagePane=document.getElementById("imagepane");

	if (ImagePane.style.display=="none") {
		ImagePane.style.display="block";
		KR_result.style.display="none";
		setText(document.getElementById("btimgshow"), "★画像隠す");
	}
	else {
		var mwid=170;
	if ( MD_result.style.display == "none" ) { mwid=10; }

	var KR_result_width = window.innerWidth - mwid;

	var KR_width = KR_result_width.toString() + "px";

		KR_result.style.width=KR_width;
		ImagePane.style.display="none";
		KR_result.style.display="block";
		setText(document.getElementById("btimgshow"), "☆画像表示");

	}
}

function WW_resize() {
	var MD_result=document.getElementById("results");
	var KR_result=document.getElementById("klarigoj_results");
    if ( KR_result.style.display == "block" ) {
        var mwid=170;
	    if ( MD_result.style.display == "none" ) { mwid=10; }
	    var KR_result_width = window.innerWidth - mwid;

	    var KR_width = KR_result_width.toString() + "px";

		KR_result.style.width=KR_width;
        KR_result.style.display = "none";
        KR_result.style.display = "block";

    }
};

function imageOnShow() {
	var result=document.getElementById("results");
	var KR_result=document.getElementById("klarigoj_results");
	var ImagePane=document.getElementById("imagepane");
	if (ImagePane.style.display=="none") {
    	result.style.display="block";
	    KR_result.style.display="none";
    	result.style.width="150px";
	    ImagePane.style.left="162px";
    	ImagePane.style.display="block";
    	setText(document.getElementById("btimgshow"), "★画像隠す");
	}
}

function hiraganani_kaeru(mojiretu) {
	var mmm;
	var kana_sw;
	var moji, kana;
	var out_kana  = "";
	var mae_moji  = "*";
	var sw        = "A";
	var error     = "Y";

	var keta_max = mojiretu.length;

	for ( mmm = 0; mmm<keta_max; ++mmm) {

    	if ( keta_max==1) {  moji = mojiretu; }
	    else { moji = mojiretu.charAt(mmm); }

	    if ( sw == "A" && moji != "(" && moji != " " ) {

		    kana_sw = kana_check(moji);

 		    if ( kana_sw != "N" ) {
			    kana  = kana_sw;
			    mae_moji = kana;

		    }
		    else
		    if ( moji == "ー" && mmm > 0 ) {
			    kana = katakana_choon_henkan(mae_moji);
		    }
		    else { kana = moji;  error = "E"; }

	    }
		if ( sw == "A" && moji == "(" )  { sw = "X"; }
		else
		if ( sw == "X" && moji == "(" )  { sw = "W"; }
		else
		if ( sw == "W" && moji == ")" )  { sw = "X"; }
		else
		if ( sw == "X" && moji == ")" )  { sw = "A"; }

		if ( sw == "A" && moji != "(" && moji != " " && moji != "　" ) {
			out_kana  = out_kana  + kana;
		}

	}// for の最後

	if (error == "E") {

		out_kana="";
	}

	return out_kana;
}

function katakana_choon_henkan(moji) {
	var mmm, mmm_max, ichi;
	var out_moji;
	var AK;

	AK =       "あぁかがさざただなはばぱまらやゃわ";  // 17 16
	AK =  AK + "いぃきぎしじちぢにひびぴみり";      // 14  31 30
	AK =  AK + "うぅくぐすずつづぬふぶぷむるゆゅ";    // 16 47  46
	AK =  AK + "えぇけげせぜてでねへべぺめれ";     // 14 61 60
	AK =  AK + "おぉこごそぞとどのほぼぽもろよょ";   // 16 77 76

    ichi = 999;
	mmm_max = AK.length;
	out_moji = "＊";
	mmm = -1;
	while ( mmm < mmm_max ) {
		++mmm;
		if ( moji == AK.charAt(mmm) ) {
			ichi = mmm;
			mmm = 999;
		}
	}
	if ( ichi < 17 ) { out_moji = "あ"; }
	else
	if ( ichi < 31 ) { out_moji = "い"; }
	else
	if ( ichi < 47 ) { out_moji = "う"; }
	else
	if ( ichi < 61 ) { out_moji = "え"; }
 	else
	if ( ichi < 77 ) { out_moji = "お"; }
	else {
         var S = " かたかな長音変換エラー　ありえない=" + moji + "=";
         alert("880 " + S);
	}

	return out_moji;

}

function kana_check(moji) {
	var out_moji;
	var mmm, mmm_max, ichi;
	var AK, BK
	AK =       "アイウエオカキクケコサシスセソタチツテト";
	AK =  AK + "ナニヌネノハヒフヘホマミムメモヤユヨラリ";
	AK =  AK + "ルレロワンヲ";
	AK =  AK + "ガギグゲゴザジズゼゾダヂヅデドバビブベボヴ";
	AK =  AK + "がぎぐげござじずぜぞだぢづでどばびぶべぼう゛";
	AK =  AK + "パピプペポッァィゥェォャュョヮ";
	AK =  AK + "ぱぴぷぺぽっぁぃぅぇぉゃゅょん";

	BK =       "あいうえおかきくけこさしすせそたちつてと";
	BK =  BK + "なにぬねのはひふへほまみむめもやゆよらり";
	BK =  BK + "るれろわんを";
	BK =  BK + "かきくけこさしすせそたちつてとはひふへほう";
	BK =  BK + "かきくけこさしすせそたちつてとはひふへほう゛";
	BK =  BK + "はひふへほつあいうえおやゆよわ";
	BK =  BK + "はひふへほつあいうえおやゆよん";

	mmm_max = AK.length;
	mmm  = -1;
	ichi = 999;
	out_moji = "N";
	while ( mmm < mmm_max - 1 ) {
		++mmm;

		if ( mmm < 46  && moji == BK.charAt(mmm) )  {
			ichi = mmm;
			mmm = 999;
		}

		else
		if ( moji == AK.charAt(mmm) ) {
			ichi = mmm;
			mmm = 999;
		}
	}

	if ( ichi < mmm_max  ) { 
		out_moji = BK.charAt(ichi);
	}

	return out_moji;

}

function hajime_mitukeru(itti_sw, mojiretu) {

	var i, hajime, kankaku, owari, naka_ichi, amari;
	mojiretu=hiraganani_kaeru(mojiretu);
    hajime = 1;
	owari  = kap_vortaro.length - 1;
	kankaku = owari - hajime;
	i = hajime;

	while ( kankaku > 3) {

		amari = kankaku % 2;
		naka_ichi=hajime + (kankaku - amari) / 2;
		var kapv=kap_vortaro[naka_ichi];
		var kapvt=kapv.split("/", 4)

		var v_yomi=kapvt[2];
		var v_ireru=kapvt[3];

		v_yomi=v_yomi.replace("$",v_ireru);
		var v_key=hiraganani_kaeru(v_yomi);

		if ( mojiretu>v_key) {
			hajime=naka_ichi;
		}
		else {
			owari=naka_ichi;
		}
		kankaku = owari - hajime;
	}
	
	var ichi=hajime;
	

    if (gVN=="Nies"){

		if (itti_sw!="200件表示"){
            if ( ichi > 30 ) { ichi = ichi - 30; }
            if ( ichi < 31 ) { ichi = 0; }
        }

		if (itti_sw=="200件表示"){
            if ( ichi > 5 ) { ichi = ichi - 5; }
            if ( ichi < 6 ) { ichi = 0; }
        }
    }

	return ichi;
}

function super_tukeru(mojiretu) {
	var keta_max=mojiretu.length;
	var outstr="";
	mmm=0;
	mae=mojiretu.charAt(0);
	while ( mmm<keta_max-1) {
		++mmm;
		amoji=mojiretu.charAt(mmm);
		if ( ( amoji=="x") || ( amoji=="X") ) {
			chapel=xnotation(mae);
			if ( chapel ) {
				mae=chapel;
				++mmm;
				}
			else {
				outstr=outstr+mae;
				mae=amoji;
				}
		}
		else {
			outstr=outstr+mae;
			mae=amoji;
			}
	}
	outstr=outstr+mae;
	document.getElementById("searchstr").value=outstr;
	return outstr;

}

function super_kaeru(mojiretu) {
	var keta_max=mojiretu.length;
	var outstr="";
	for ( mmm = 0; mmm<keta_max; ++mmm) {
		amoji=mojiretu.charAt(mmm);
		for ( i = 0; i<12; ++i) {
			super_hairetu = Sup_moji[i];
			super_moji = super_hairetu[0];
			x_moji = super_hairetu[1];
			if (amoji==super_moji) { amoji=x_moji}
			}
		outstr=outstr+amoji;
		}
	return outstr;
}

function Al_minisklo(mojiretu) {
	var keta_max=mojiretu.length;
	var outstr="";
	for ( mmm = 0; mmm<keta_max; ++mmm) {
		amoji=mojiretu.charAt(mmm);
		acode=mojiretu.charCodeAt(mmm);
		if ( acode > 64  && acode < 91 ) {
			acode = acode + 32;
			amoji = String.fromCharCode(acode);
			}
		outstr=outstr+amoji;
		}
	return outstr;
}

function Al_majusklo(mojiretu) {
	var keta_max=mojiretu.length;
	var outstr="";
	for ( mmm = 0; mmm<keta_max; ++mmm) {
		amoji=mojiretu.charAt(mmm);
		acode=mojiretu.charCodeAt(mmm);
		if ( acode > 96  && acode < 123 ) {
			acode = acode - 32;
			amoji = String.fromCharCode(acode);
			}
		if (amoji == "X") { amoji = "x" }
		outstr=outstr+amoji;
		}
	return outstr;
}

function romaji_check(mojiretu) {
	var sw="Y";
	mojiretu=super_kaeru(mojiretu);
	mojiretu=Al_minisklo(mojiretu);
	var keta_max=mojiretu.length;
	for ( mmm = 0; mmm<keta_max; ++mmm) {
		amoji=mojiretu.charAt(mmm);
		acode=mojiretu.charCodeAt(mmm);
		if ((acode < 97 || acode > 122) && ( amoji!=" " )) {
			sw = "N";
			}
		}
	return sw;
}

function boin_check(mj) {
	var sw="No";
	for ( mmm = 0; mmm<5; ++mmm) {
		data = Boinretu[mmm];
		romaji=data[0];
		kana=data[1];
		if ( mj==romaji ) { sw = kana; }
		}
	return sw;
}

function siin_check(mj) {
	var sw=999;
	mmm=-1;
	while ( mmm<20 ) {
		++mmm;
		data = Siinretu[mmm];
		romaji=data[0];
		loko=data[1];
		if ( mj==romaji ) {
			sw = loko;
			mmm=mmm+99;
			}
		}
	return sw;
}

function dabri_check(mojiretu) {
	var sw=999;
	mmm=-1;
	while ( mmm<Dabrretu.length-1) {
		++mmm;
		data = Dabrretu[mmm];
		romaji=data[0];
		loko=data[1];
		if ( mojiretu==romaji ) {
			sw = loko;
			mmm=mmm+99;
			}
		}
	return sw;
}

function moji_set(hairetu) {
	var sw=999;
	mojiretu=hairetu[0];
	hajime=hairetu[1];
	mmm=hajime-1;

	owari=mmm+5;
	while ( mmm < owari) {
		++mmm;
		data = Rom_Hira[mmm];
		romaji=data[0];
		kana=data[1];
		if ( mojiretu==romaji ) {
			sw = kana;
			mmm=mmm+99;
			}
		}
	if (sw==999) { sw=mojiretu }
	return sw;
}

function romaji_seiri(kubun, mojiretu) {

	mojiretu=Al_minisklo(mojiretu);

	var outH="";//ひらがな用
	var outK="";//★カタカナ用
	var Hs="";//ひらがな用
	var OK;
	var keta_max=mojiretu.length;
	mojiretu=mojiretu+" ";
	var z=-1;

    while ( z < keta_max-1) {

    	z=z+1;
	    amj=mojiretu.charAt(z);
    	if ( z < keta_max-1) {bmj=mojiretu.charAt(z+1);} else {bmj="";}
    	if ( z < keta_max-2) {cmj=mojiretu.charAt(z+2);} else {cmj="";}

    	if ((amj!=" ")&&( boin_check(amj) != "No" )) {
	    	OK="母音";
		    Hs=boin_check(amj);

		}
		else

    	if (amj!=" ") {//111111
	    	siin_loko=siin_check(amj);

		    if ( boin_check(bmj) != "No" ) {//22
			    OK="子音母音";
			    hairetu=[amj+bmj, siin_loko];
			    Hs=moji_set(hairetu);

			    z=z+1;
			}//22

    		else {// 22
    			abmj=amj+bmj;
	    		dabri_loko=999;
    			if (bmj=="y" || bmj=="h" || bmj=="w" || bmj=="s" ) {
	    			dabri_loko=dabri_check(amj+bmj);
		    	}
			    else
				if ( abmj=="lt" ) {
					dabri_loko=247;
					}

			    if ( dabri_loko < 999 ) {//33
			        if ( z < keta_max-2 ) {//44
				        var cmj=mojiretu.charAt(z+2);
			            if ( boin_check(cmj) != "No" ) {//55
				            hairetu=[amj+bmj+cmj, dabri_loko];
				            Hs=moji_set(hairetu);
				            //Hs=amj+bmj+cmj;
				            z=z+2;
				        }//55

				        else {
				            Hs=amj+bmj;//+"*A1182";
					    }//55--
				    }//44
                    else
			        if ( z == keta_max-2 ) {//44-1
				        Hs=amj+bmj;//+"*B1186"+dabri_loko;
				        z=z+1;
				    }//44-1
			    }//33

    			if ( dabri_loko == 999 ) {//333
	    		if ( (amj==bmj) && (amj != "n") ) {//66

    				Hs="っ";
	    			if ( z == keta_max-2 ) { z=z+1; }
				}//66
				else
    			if ( (amj==bmj) && (amj == "n") ) {//66--

	    			Hs="ん";
		    		z=z+1;
				}//66
				else
    			if ( (amj == "n") && (bmj == "") ) {//66--

	    			Hs="ん";
				}//66
				else
    			if ( (amj == "n") && (bmj != "") ) {//66--

	    			Hs="ん";
				}//66
				else
    			if (z<keta_max-1)  {
	    			Hs=amj//+"*C1207";//『例kr, nk』
				}//66
				else {
					Hs=amj;//+"*E1205";
					}//66--
				}//333

			}//22--

		}//1111111
		else
		if (amj==" "){Hs=" ";}

        var keta=outH.length;

        var mae_moji="";
        if (outH!=""){mae_moji=outH.substring(keta-1);}

	    outH=outH+Hs+"";
	}//while fin

	var out=outH;

    if (kubun=="H") {
	    out = outH;
    }

    if (kubun=="w") {
	    outK=katakanani_kaeru(outH);
	    out = outH + "|" + outK;
    }

	return out;
}

window.onresize= function() {
	setPagingClickRange();

}

var o_x_prev=420;

var o_x_next=680;

function setPagingClickRange() {
	var width_body= window.innerWidth;	//NOTE !!
	if (!width_body)
		return;
	var width_img = parseInt(document.getElementById("pageimg").width);
    var g_ListWidth=150;

	o_x_prev= Math.round(width_img/3)   + g_ListWidth;
	o_x_next= Math.round(width_img/3*2) + g_ListWidth;

}

function Img_OnMouse_move(evt) {
	var target;
	if (window.event) {
		evt= window.event;
		target= window.event.srcElement;
	}
	else {
		target= evt.target;
	}

	if (evt.clientX <= o_x_prev) {
		target.style.cursor= 
'url(sistem_img/PagePrev.gif),url(sistem_img/PagePrev.cur),w-resize';
	}
	else if (evt.clientX >= o_x_next) {
		target.style.cursor= 
'url(sistem_img/PageNext.gif),url(sistem_img/PageNext.cur),e-resize';
	}
	else {
		target.style.cursor= "default";	//"move";
	}
}

function Img_OnMouse_down(evt) {

	var x_ichi_0 = 150;
	var y_ichi;

	var ppp=0;

	try {
		x_ichi = evt.pageX;
		y_ichi = evt.pageY;
	}catch(evt){
		x_ichi = event.pageX;
		y_ichi = event.pageY;
	}
	if ( x_ichi == undefined ) {
		x_ichi=evt.clientX;
		y_ichi=evt.cliendY;

	}

	xxx=parseInt(x_ichi);
	if (xxx < o_x_prev) { ppp=-1;  }
	if (xxx > o_x_next) { ppp=1;  }

	if ( gtest=="yes" ) {
		x_ichi = xxx.toString();
		alert("1377マウスを押した x 座標=" + x_ichi);
		}
	if ( ppp!=0 ) { showPage(ppp); }
}

function search_str_clear() {
	document.getElementById("searchstr").value="";
	document.getElementById("searchstr").focus();

	search();
}

function search() {

	var ImagePane=document.getElementById("imagepane");
	if (ImagePane.style.display=="block"){
		imageShow();
		}

	var KPresults=document.getElementById("results");
	KPresults.innerHTML="";
	var KRresults=document.getElementById("klarigoj_results");
	KRresults.innerHTML="";
	var schstr= document.getElementById("searchstr").value;

	var moto_schstr=schstr;
	if (schstr=="") {

		return;
	}

	var itti_check=itti_henkan(schstr);
	var Tokubetu=itti_check[1];
	schstr=itti_check[0];

    var trovita = 0;
    var page_ichiA="";

    var tango_ichiA=0;

    var p=0;
    var taisho_sw="midasi";
    var itti_sw  ="";
    if (document.Kensaku_option.RadioG[0].checked)
			{itti_sw  ="部分一致";}
	if (document.Kensaku_option.RadioG[1].checked)
			{itti_sw  ="前方一致";}
	if (document.Kensaku_option.RadioG[2].checked)
			{itti_sw  ="完全一致";}
	if (document.Kensaku_option.RadioG[3].checked)
			{itti_sw  ="語尾一致";}
	if (document.Kensaku_option.RadioG[4].checked)
        	{itti_sw  ="200件表示";}

    if (document.Kensaku_option.RadioGA[1].checked) {taisho_sw = "zentai";}
    if (document.Kensaku_option.RadioGA[2].checked) {taisho_sw = "page";}

    if ( (gVN=="Nies") && (taisho_sw!="zentai") ) {//MMMMMMMMMMMM●●●
		var H_schstr=schstr;
		var romaji = schstr;

		if (romaji_check(romaji)=="Y") {
				schstr=romaji_seiri("w", romaji);
				H_schstr=romaji_seiri("H", romaji);
		}

    var bunri_ichi = H_schstr.indexOf("|");
    if ( bunri_ichi > -1 ) {H_schstr=H_schstr.substring(0, bunri_ichi);}

	var kanaA=hiraganani_kaeru(H_schstr);

		if ((itti_sw !="部分一致")&&(itti_sw !="語尾一致"))
		if (kanaA!=""){

			kanaA=kanaA.replace("う゛", "う");

			tango_ichiA=hajime_mitukeru(itti_sw, kanaA);

		}

		var H_check="N";
		H_check=hiraganaretu_check(schstr);
		if (H_check=="Y"){
			schstr=choon_shori(schstr);
			var katakana=katakanani_kaeru(schstr);
			schstr=schstr + "|" + katakana;
			}
	}//MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
	
if ((kanaA=="")&&(itti_sw=="200件表示")){alert("『200件表示』で漢字は使えません。表示結果は正しく出ません。");}

	schstr=convSpChars(schstr, document.getElementById("opOR").checked, document.getElementById("wildcard").checked);

	var casesensitive=document.getElementById("casesensitive").checked;

    var reStr, reAndStrs;

	if (document.getElementById("refine").checked) {
		var strs=schstr.split(/ *& */);

		if (strs.length==1) {
			reStr= new RegExp(strs[0], casesensitive? "":"i");
		}
		else {
			reAndStrs=new Array();
			var i;
			for (i=0; i<strs.length; ++i)
				reAndStrs[i]=new RegExp(strs[i],
casesensitive? "":"i");
		}
	}
	else {
		reStr= new RegExp(schstr, casesensitive? "":"i");
	}

	var KPfrag= document.createDocumentFragment();
	var KRfrag= document.createDocumentFragment();

var out_x=0;

var keikoku="";
if ((kanaA=="")&&(itti_sw=="200件表示")){keikoku="== ★★警告★★　『200件表示』で漢字は使えません。表示結果は正しく出ません。";}
	var div= makeResultH("r", "0001L", "◎◎◎　検索開始　　◎◎◎ 検索文字＝＝"+schstr + keikoku+"==");

        KRfrag.appendChild(div);

var v=tango_ichiA;
	 pub_moto_sch_retu=moji_departi(schstr);

var vortaro_owari=vortaro.length;

tango_ichiA = tango_ichiA * 1;
if (taisho_sw=="page"){
 if ( tango_ichiA < vortaro.length - 200) {vortaro_owari = tango_ichiA + 200;}
 }
if ( ( ( itti_sw == "前方一致" ) || ( itti_sw == "完全一致" ) ) &&
   ( taisho_sw=="midasi" ) && (kanaA!="") ) {
	 vortaro_owari = tango_ichiA + 400;  
	 if (vortaro_owari > vortaro.length) {vortaro_owari=vortaro.length;} 
   } 
 

while (v<vortaro_owari) {

var vorto=kap_kigoo_shori(kap_vortaro[v]);

var yomi=vorto[2];
var ireru_midasi = vorto[3];

var tuika_midasi = vorto[4];

var setumei=vortaro[v];

var klarigoj = setumei;

var kapvorto=vorto[1];

var kap_keta=kapvorto.length;

trovita = 0;

var kapo="　" + kapvorto + "　" + yomi + "　" + tuika_midasi + "　";
if  (gVN=="Nies"){kapo = kapo + "　" + ireru_midasi;}

var zentai = kapo + " " + klarigoj;
var taisho=zentai;

if (taisho_sw=="midasi"){taisho=kapo;}

if (taisho_sw == "zentai") {
taisho = kurikaesi_henkan(ireru_midasi, taisho);
}

trovita = 0;

    if (taisho_sw!="page") {

        taisho = taisho.replace(/\,/g, "　");
        taisho = taisho.replace(/\./g, "　");
        taisho = taisho.replace(/\;/g, "　");
        taisho = taisho.replace(/\:/g, "　");
        taisho = taisho.replace(/\?/g, "　");
        taisho = taisho.replace(/\!/g, "　");
        taisho = taisho.replace(/＝/g, "　");
        taisho = taisho.replace(/\(/g, "　");
        taisho = taisho.replace(/\)/g, "　");
        taisho = taisho.replace(/\[/g, "　");
        taisho = taisho.replace(/\]/g, "　");

        taisho = taisho.replace(/\%/g, "　");
    }
	

if ( (taisho_sw!="page") && (Tokubetu=="gxen") ) {
	if (reStr && reStr.test(taisho) || reAndStrs &&
andsearch(reAndStrs, taisho)) {trovita=1;}
}

if ( (taisho_sw!="page") &&  (Tokubetu=="spec") ) {

var zentai_A=space_henkanA(taisho);

	if (reStr && reStr.test(zentai_A) || reAndStrs &&
andsearch(reAndStrs, zentai_A)) {trovita=1;}

}

if (taisho_sw=="page") {trovita=1;}

if ( trovita==1 ){//CCCCCCCCCCCCCCCCCCC

	var pxLR, pxLRGN, kap_hidari, vorto_linio, kanren;

	pxLR=vorto[0];

    kanren = klarigoj.substring(0,3);

    kap_hidari = moji_irekae(pub_moto_sch_retu, "★" + kapvorto);

	kap_hidari = kap_hidari.replace("★", "");
	

	var div= makeResultH("r", pxLR, kap_hidari);

	KPfrag.appendChild(div);

    var kl=klarigoj;
	

	

    if  (gVN=="Nies") {kl="■　" + kapvorto + "★　" + kl;}
	kl = kl + " ";//2017.06.09修正
    var keta = kl.length;
    var k = 0;
    var moji, ato_moji;
	vorto_linio="";

while ( k < keta ) {//1111111111     0 から keta-1 まで

moji = kl[k];
ato_moji=" ";
if ( k < keta-1 ) { ato_moji=kl[k+1]; }

if ( ( moji=="%") || ( k==keta-1) ) {//222222222

vorto_linio = kurikaesi_henkan(ireru_midasi, vorto_linio);

var gentei=document.getElementById("Ekzemplo").checked;

var out_ok="1";
var itibu="0";

if (gentei){itibu="1"; out_ok="0";

	var vorto_tttt=vorto_linio;
	if (Tokubetu=="spec") {
		vorto_tttt = vorto_tttt.replace(/<\/i>/g, "");
		vorto_tttt = vorto_tttt.replace(/<i>/g, "");
		vorto_tttt    =space_henkanA(vorto_tttt);
	}

	if (reStr && reStr.test(vorto_tttt) || reAndStrs &&
andsearch(reAndStrs, vorto_tttt)){out_ok="1";}else
		//{if (vorto_linio[0]=="★"){out_ok="1";}}//0602修正	
{if (vorto_linio[0]=="■"){out_ok="1";}}

}

if ( (itibu=="0") || ( ( itibu=="1") && (out_ok=="1") ) ) {

	vorto_linio = moji_irekae(pub_moto_sch_retu, vorto_linio);

	vorto_linio = italic_irekae(vorto_linio);

	var vl_keta=vorto_linio.length;

	if ( vorto_linio[0]=="　" || vorto_linio[0]==" "  )
	{ vorto_linio = vorto_linio.substring(1,vl_keta)}

	var space_aaa="";

	if (( gVN=="Nies" ) &&  ( vorto_linio[0]=="★" ) )
			{ vorto_linio="☆★"+ vorto_linio.substring(6);}
	else
	if (( gVN=="Nies" ) &&  ( vorto_linio[0]=="■" ) )
			{ vorto_linio=vorto_linio.replace("■　", "★");}
	else
	if ( vorto_linio[0]=="〖" )  {space_aaa="　";}
	else
	if ( vorto_linio[0]=="★" ) { space_aaa=""; }
	else

	if ( vorto_linio[0]=="〔" ) { space_aaa="　　　　　"; }
	else

	if ( vorto_linio[0]=="⇒" ) { space_aaa="　　　　　　"; }
	else

	if ( vorto_linio[0]=="¶" ) { space_aaa="　　　"; }
	else { space_aaa="　　　　"; }

	vorto_linio=space_aaa + vorto_linio;

	
	if ( gVN=="Nies" ) {
        vorto_linio = vorto_linio.replace("&&", "〖補遺〗　");
        vorto_linio = vorto_linio.replace("$$", "〖付録〗　");
    }

	div= makeResultH("r", pxLR, vorto_linio);

	KRfrag.appendChild(div);

	}

	vorto_linio="";

}//22222222

	if (moji != "%") {vorto_linio = vorto_linio + moji;}

	++k;
}//11111111111

++out_x;

if (out_x>200) {//  DDDDDD  

v=vortaro.length + 999999;

	div= makeResult("r", pxLR, "以下略");
	KPfrag.appendChild(div);

	div= makeResult("r", pxLR, "見出し単語で200件越える部分は省略");
        KRfrag.appendChild(div);

}//   DDDDDD

}//   CCCCCC

++v;

 }//  BBBBBB

	div= makeResult("r", pxLR, "●●終わり●●");
	KPfrag.appendChild(div);
	div= makeResult("r", pxLR, "●●●検索結果リスト終わり●●●");
        KRfrag.appendChild(div);

	KPresults.appendChild(KPfrag);
	KRresults.appendChild(KRfrag);

}

function moji_departi(str) {
    var retu=["", "", "", "", "", "", "", "", "", ""]
    var keta=str.length;
    var i
    var r=0;
    var moji="";
    for (i=0; i<keta; ++i) {
        if ( ( str[i] == "&" ) || ( str[i] == "|" ) || ( str[i] == "*" ) ) {
            retu[r]=moji;
            moji="";
            ++r;
        }else{
            if ( (str[i]== " ") || (str[i]== "　") ){

            	moji=moji+"　";
            }
            else {moji=moji+str[i];}
        }
    }

    retu[r]=moji;
    for (i=0; i<r+1; ++i) {
        moji=retu[r];
        if (moji==" "){moji=""}
        var keta=moji.length;
        if ((keta>1)&&(moji[keta]==" ")){
                retu[r]=moji.substring(0,keta-1);
        }

    }
    return retu;
}

function makeResultH(klass, page, html_line) {
	var div= document.createElement("div");
	div.className=klass;
	div.setAttribute("params", page);
	div.innerHTML=html_line;
	return div;
}

function moji_irekae(hairetu, str) {

	

    var tag1="<span style=\"color:#FF0000\">";
    var tag2="</span>";

    var tag3="<span style=\"color:#33CC33\"><B>";
    var tag4="</B></span>";
    var novstr=str;
    var i=-1;
    var j=-1;
    var k=-1;
    var nokori_x;
    var amoji, AAmoji, bmoji, BBmoji, next_bmoji, next2_bmoji, next3_bmoji, next4_bmoji, check, next_amoji;
    var acode, AAcode, bcode, BBcode;
    var nagasa, kensu;

    var str_max;

    while (i<hairetu.length) {
        ++i;
        if (hairetu[i]=="") { kensu=i; i=99;}
    }

    i=-1;

    while (i<kensu-1) {//aaaaaaaaaaa
        str=novstr;
        novstr="";
        ++i;

        str_max =str.length;

        retu=hairetu[i];

        nagasa=retu.length;

        if ((nagasa > 1) &&  ((retu[0] == "　") || (retu[0] == " "))){
            retu = retu.substring(1, nagasa);
        }
        nagasa=retu.length;		

        if ((nagasa>1) && ((retu[nagasa-1] == "　") || (retu[nagasa-1] == " "))){
            retu = retu.substring(0, nagasa-1);
        }
        nagasa=retu.length;

        sama_A="";

        sama_B="";
        j=-1;
        hosi_x=0;
        sw ="A";

    	while (j<str_max-1) {//bbbbbbbbbb
            nokori_x=0;
            ++j;

            k=0;

        	while (k<nagasa){//ccccccccccccc

                amoji=retu[k];
                if ( k < nagasa-1 ) { next_amoji = retu[k+1]; } else { next_amoji = "　"; }

                bmoji=str[j];

                if ( j < str_max-1 ) { next_bmoji  = str[j+1]; } else { next_bmoji  = "　"; }
                if ( j < str_max-2 ) { next2_bmoji = str[j+2]; } else { next2_bmoji = "　"; }
                if ( j < str_max-3 ) { next3_bmoji = str[j+3]; } else { next3_bmoji = "　"; }
                if ( j < str_max-4 ) { next4_bmoji = str[j+4]; } else { next4_bmoji = "　"; }
                check = next_bmoji + next2_bmoji + next3_bmoji;

                var MasMaj=0;
                if (document.getElementById("casesensitive").checked) {MasMaj=1;}

                if (MasMaj==1) {AAmoji=amoji; BBmoji=bmoji;}

                if (MasMaj==0) {//mmmmmmmmmmmmmmmmmmmmmm
                    acode=amoji.charCodeAt(0);
                    bcode=bmoji.charCodeAt(0);

                    if ( (acode>96)&&(acode<123) ){AAcode=acode-32;}
                    if ( (acode==265)||(acode==285)||(acode==293)||
                         (acode==309)||(acode==349)||(acode==365)){AAcode=acode-1;}

                    if ( (acode>64)&&(acode<91) ){AAcode=acode+32;}
                    if ( (acode==264)||(acode==284)||(acode==292)||
                         (acode==308)||(acode==348)||(acode==364)){AAcode=acode+1;}
                    AAmoji  = String.fromCharCode(AAcode);
                }//mmmmmmmmmmmmmmm

                if (gVN=="Nies"){

        	        if ( (bmoji=="★")||(bmoji=="【") ){
            	    ++hosi_x;
	                }
                	if ( (sama_B!="")&&(hosi_x==1)&&(amoji!="・")&&(bmoji=="・") ){
        	        ++hosi_x; amoji=""; AAmoji="・"; k=k-1;
            	    }
                }

                if ( ( (MasMaj==0) && ((amoji==bmoji) || (AAmoji==bmoji))) ||
                     ( (MasMaj==1) && (amoji==bmoji) ) ) {//ddddddddd

                    sama_A=sama_A + amoji;
                    sama_B=sama_B + bmoji;

                    if (k==nagasa-1) {//eeeeeeee 
            	        novstr=novstr + tag1 + sama_B + tag2;
                        sama_A="";
                        sama_B="";

                        k=-1;
                    }//eeeeeeee

                    ++k
                    ++j

                    if ( (sama_B!="")&& (((next_amoji!="・")&&(next_bmoji=="・") )|| ((next_amoji!="|")&&(next_bmoji=="|")) ) ) {
                        j=j+1; sama_B=sama_B + next_bmoji;
                    }

                    if ( (sama_B!="")&&(next_amoji!="<")&&(next_bmoji=="<") ){
                        if (check=="<i>") {j=j+3; sama_B=sama_B + check;}
                        if (check=="</i") {j=j+4; sama_B=sama_B + check + next4_bmoji;}
                    }

                }

				else{//dddddd 
				

                    if (0<sama_A.length){//ffffffffff

                        j=j-sama_B.length;

                        sama_A="";
                        sama_B="";
                    }//ffffffffffffff

                    k=0;
                    novstr=novstr+str[j];
                    ++j
                }//ddddddddddddd

                if (j>str_max-nagasa+sama_A.length){// ggggggg

                   	for (r=j; r<str_max; ++r){
                    novstr=novstr+str[r];
	                }
               	    k=k+999;
                    j=j+99999;
    	        }//ggggggggg

        	}//ccccccccccccc
    	}//bbbbbbbbbbbbbbbb
    }//aaaaaaaaaaaaa

    return novstr;

}

function space_henkanA(zentai) {
    var i, moji;
    var out="";

    zentai=zentai.replace(/\(\(/g,"");
    zentai=zentai.replace(/\)\)/g,"");
    for (i=0; i<zentai.length; ++i){
        moji=zentai[i];
        if ((moji==";")  || (moji==":")  || (moji=="?")  || (moji=="?")  ||
            (moji==".")  || (moji==",")  || (moji=="。") || (moji=="、") ||
            (moji=="(")  || (moji==")")  || (moji=="（") || (moji=="）") ||
            (moji=="[")  || (moji=="]")  || (moji=="〔") || (moji=="〕") ||
            (moji=="!")  || (moji=="?")  || (moji=="！") || (moji=="？") ||
            (moji=="/")  || (moji=="【") || (moji=="】") || (moji=="―") ||
            (moji=="★") || (moji=="%") || (moji=="　") || (moji=="◆") || (moji=="※") || 
            (moji=="－") ) { moji=" ";}
        if ((moji=="・") || (moji=="?")  || (moji=="-"))  {moji="";}

        out=out+moji;
    }

return out;
}

function itti_henkan(str) {
    var out=[str, "gxen"];
    var Tok="gxen";
    var ittiSw=0;//

    for(var i=1; i<4; ++i){
        if (document.Kensaku_option.RadioG[i].checked)
	        {ittiSw=i; Tok="spec";}
    }

    for (var p=0; p<4; ++p){str = str.replace("　", " ");}

    var check = str.replace(" ", "");
    if (check!=str){Tok="spec";}

    var MSK=str.length;
    var hukugou="0";
    var moji;

    if (ittiSw!=0) {
        if (( ittiSw>1)&&(str[MSK-1]!=" ")) {str=str + " ";}
        if ( (ittiSw<3)&&(str[0]!=" "))     {str=" " + str;}
    }

    for (var i=1; i<4; ++i){
    	if (ittiSw==1) {
	    	str=str.replace("|", "| ");
		    str=str.replace("&", "& ");
    	}
	    if (ittiSw==2) {
		    str=str.replace("|", " | ");
		    str=str.replace("&", " & ");
    	}
	    if (ittiSw==3) {
		    str=str.replace("|", " |");
		    str=str.replace("&", " &");
    	}
	    str=str.replace("  ", " ");
    }

    out[0]=str;
    out[1]=Tok;

    return out;
}

function kurikaesi_henkan(ireru_midasi, str) {
    if (gVN=="Nies"){
        str= str.replace(/～/g, ireru_midasi);
    }
    return str;
}

function modeChange() {

    var ittiSwA=0;
    var ittiSwB=0;
    var kubun1="見出";
    var kubun2="前方";
    var hanni=["見出・", "全文・", "前後"];
    var itti =["部分一致", "前方一致", "完全一致", "語尾一致", "200件表示"];
    for(var i=0; i<3; ++i){
	    if (document.Kensaku_option.RadioGA[i].checked){
	    ittiSwA=i; kubun1=hanni[i];
		}
    }
    for(var j=0; j<5; ++j){
	    if (document.Kensaku_option.RadioG[j].checked){
	        ittiSwB=j; kubun2=itti[j];
		}
    }
    if (ittiSwA==0)
        {ittiSwA=1;ittiSwB=0;kubun1="全文・";kubun2="部分一致";}
    else
    if (ittiSwA==1)
        {ittiSwA=2;ittiSwB=4;kubun1="前後";kubun2="200件表示";}
    else
    if (ittiSwA==2)
        {ittiSwA=0;ittiSwB=1;kubun1="見出・";kubun2="前方一致";}

    document.Kensaku_option.RadioGA[ittiSwA].checked=true;
    document.Kensaku_option.RadioG[ittiSwB].checked=true;
    document.getElementById("btnmode").innerHTML ="<font size=1 color=blue>" + kubun1 + kubun2 + "</font>";
}

function onRadioButtonChange() {
    var ittiSwH=0;
    var ittiSwI=0;
    var kubun1="見出";
    var kubun2="前方";
    var hanni=["見出・", "全文・", "前後"];
    var itti =["部分一致", "前方一致", "完全一致", "語尾一致", "200件表示"];
    for(var i=0; i<3; ++i){
	    if (document.Kensaku_option.RadioGA[i].checked){
	    ittiSwH=i; kubun1=hanni[i];
		}
    }
    if (ittiSwH==2){document.Kensaku_option.RadioG[4].checked=true; kubun2=itti[4];}

    for(var i=0; i<5; ++i){
	    if (document.Kensaku_option.RadioG[i].checked){
	    ittiSwI=i; kubun2=itti[i];
		}
    }
    if ((ittiSwH==0)&&(ittiSwI==4)){document.Kensaku_option.RadioG[1].checked=true; kubun2=itti[1];}
    if ((ittiSwH==1)&&(ittiSwI==4)){document.Kensaku_option.RadioG[0].checked=true; kubun2=itti[0];}

	document.getElementById("btnmode").innerHTML ="<font size=1 color=blue>" + kubun1 + kubun2 + "</font>";

}

function katakanani_kaeru(mojiretu) {
	var sw, mae_moji, moji, out_moji;
	var out="";
	var kkk, mmm, mmm_max, ichi, B_max;
	var AK, BK, CK;
	var keta=mojiretu.length;

	AK =       "アカサタナハマヤラガザダバパァャワ";//17
	AK =  AK + "イキシチニヒミリギジヂビピィ";//14 31
	AK =  AK + "ウクスツヌフムユルグズヅブプゥュ";//16 47
	AK =  AK + "エケセテネヘメレゲゼデベペェ";//14 61
	AK =  AK + "オコソトノホモヨロゴゾドボポォョ";//16 77
	AK =  AK + "ヲンッヴーアア";//83 

	BK =       "あかさたなはまやらがざだばぱぁゃわ";//17
	BK =  BK + "いきしちにひみりぎじぢびぴぃ";//14
	BK =  BK + "うくすつぬふむゆるぐずづぶぷぅゅ";//16
	BK =  BK + "えけせてねへめれげぜでべぺぇ";//14
	BK =  BK + "おこそとのほもよろごぞどぼぽぉょ";//16
	BK =  BK + "をんっうーああ";//83

	mmm_max = AK.length;
	B_max = BK.length;
	if (mmm_max!=B_max){
		alert("2553 かなリストがError");
		alert("2555 mmm_max=" + mmm_max + "=");
		}

	k=-1;
	sw="";
	while(k<keta-1){//AAAAAAAAAAAAAAAA
		++k;
		moji=mojiretu.charAt(k);
		mmm  = -1;
		ichi = 999;
		out_moji = moji;
        while ( mmm < mmm_max ) {//BBBBBBBBBBBBBB
    		++mmm;
    		if ( (mmm < 82)  && (moji == BK.charAt(mmm)) )  {//CCC
    			ichi = mmm;
    			out_moji = AK.charAt(mmm);
    			mmm = 999;
			}//CCC
		}//BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB

		if  ( sw==moji) { out_moji="ー";}
		if  (( sw=="う")&&(moji=="゛")) { out_moji="ヴ";}
		if ( ichi < 17 ) { sw = "あ"; }
		else
		if ( ichi < 31 ) { sw = "い"; }
		else
		if ( ichi < 47 ) { sw = "う"; }
		else
		if ( ichi < 61 ) { sw = "え"; }
		else
		if ( ichi < 77 ) { sw = "お"; }
		else             { sw = ""; }

        if (out_moji=="ヴ"){out=out.replace("ウ", "ヴ");}//★★★完成
        else out=out + out_moji;

    }//AAAAAAAAAAAAAAAAAA

	return out;
}

function hiraganaretu_check(mojiretu) {
	var k, sw, moji, code;
	var keta=mojiretu.length;
	sw="Y";

	for (k=0; k<keta; ++k){
		moji=mojiretu.charAt(k);
		code=mojiretu.charCodeAt(k);
		if ( (moji!="ー") && (moji!=" ") && (moji!="　") &&
		 (moji!="|") && (moji!="&") &&  (moji!="*") &&
		 ((moji<"ぁ" ) || ( moji>"ん" ))) {sw="N";}
		}
	return sw;
}

function choon_shori(mojiretu) {
	var moji, mae_moji;
	var out=mojiretu.charAt(0);
	for (var i=1; i<mojiretu.length; ++i){
		moji=mojiretu.charAt(i);
		mae_moji=mojiretu.charAt(i-1);
		if (moji=="ー"){moji=katakana_choon_henkan(mae_moji);}
		out=out+moji;
	}
	return out;
}

function italic_irekae(str) {

    var tag1="<span style=\"color:#0066FF\">";
    var tag2="</span>";
    var novstr="";
    var span_sw=""; var italic_sw="";
    var j=-1;
    var bmoji, next1_bmoji, next2_bmoji, next3_bmoji;
    var next4_bmoji, check3, check4, tobasi;

    var str_max;

    str_max =str.length;

	while (j<str_max-1) {//bbbbbbbbbb　
        ++j;
        bmoji = str[j];
        if ( j < str_max-1 ) { next1_bmoji = str[j+1]; } else { next1_bmoji = "　"; }
        if ( j < str_max-2 ) { next2_bmoji = str[j+2]; } else { next2_bmoji = "　"; }
        if ( j < str_max-3 ) { next3_bmoji = str[j+3]; } else { next3_bmoji = "　"; }
        if ( j < str_max-4 ) { next4_bmoji = str[j+4]; } else { next4_bmoji = "　"; }

        check3 = bmoji + next1_bmoji + next2_bmoji;
        check4 = bmoji + next1_bmoji + next2_bmoji + next3_bmoji;

        if  (bmoji=="<") {//ppppppppppppppp

            if  (check4=="<spa") {  
                span_sw="span";
                if (j+28 < str_max ) {tobasi = str.substring(j, j+28);}
                else {tobasi = str.substring(j, str_max-1) + "●●●●●";}
                novstr = novstr + tobasi;
                j= j+27;
            }
            else

            if  (check4=="</sp") { 
                span_sw="";
                if (j+7 < str_max ) {tobasi = str.substring(j, j+7);}
                else{tobasi = str.substring(j, str_max-1) + "●●●●●";}
                novstr = novstr +  tobasi;
                j =j+6;
            }
            else

            if  (check3=="<i>")  {  
                italic_sw="italic";
                novstr = novstr + check3;
                j =j+2;
                if (span_sw==""){ novstr = novstr + tag1; }
            }
            else

            if (check4=="</i>")  { 
                italic_sw="";
                if (span_sw==""){ novstr = novstr + tag2; }
                novstr = novstr + check4;
                j =j+3;
            }
            else {
                novstr = novstr + bmoji;
                j=j;
              }

        }//pppppppppppppppppppppppppp
        else{
            novstr = novstr + bmoji;

        }
	}//bbbbbbbbbbbbbbbb

    return novstr;
}

function kigooka_shori(initv){

	var Kmax=vortaro.length;

	var s_time=new Date();
	var m=pub_hajime;

	if (pub_mez > Kmax) {pub_mez=Kmax;}

	for (x=1; x<12; ++x){//FFF
		while ((m<pub_mez-1)&&(m<Kmax-1)){//AAA
			++m;
			var Kds=vortaro[m];
			if (initv!=''){
				var t= window.atob(Kds);
				t= rc4_crypto(t, initv);
				Kds= utf8to16(t);
			}
			vortaro[m]=" " + kigooka_setumei_unu(Kds);

		}//AAA
		var m_time = new Date();
		pub_keika = m_time - s_time;
		if (parseInt(pub_keika)<10000){
			pub_mez=5000 + pub_mez;
			if (pub_mez>Kmax){pub_mez=Kmax;}
			if ((pub_mez==10000)&&(pub_keika>600)){showMessageBox("記号化を解除しています");}			
		}		
	}//FFF
	var w_time= new Date();
	pub_keika = w_time - s_time; 
	pub_hajime = m;	

}	

function kigooka_setumei_unu(Kds){

	var Kketa=Kds.length;
	var code1, code2, code3, num;
	var outds="";
	var k=-1;
	
	while (k < Kketa-3){
		++k;
		code1=Kds.charCodeAt(k);
		code2=Kds.charCodeAt(k+1);		
		code3=Kds.charCodeAt(k+2);		
		if (((code1>122)||(code1<65)||((code1>90)&&(code1<97))) ||
			((code2>122)||(code2<65)||((code2>90)&&(code2<97))) ||
			((code3>122)||(code3<65)||((code3>90)&&(code3<97)))){			
				if ((code1>20000)&&(code1<24247)){
					outds=outds + String.fromCharCode(jlk[code1-20001]);
					}			
					else{
					outds = outds + String.fromCharCode(code1);
					}
		}
		
		else{
			k=k+2;

			if (code1<91){code1=code1-65;}else{code1=code1-71;}
			if (code2<91){code2=code2-65;}else{code2=code2-71;}
			if (code3<91){code3=code3-65;}else{code3=code3-71;}					
			num = code1*2704+code2*52+code3;
			var ekey = esp_key[num];
			outds = outds + ekey + " ";
		}
		
	}
	

	while (k < Kketa-1){
				++k;
				code1=Kds.charCodeAt(k);
				if ((code1>20000)&&(code1<24247)){
					outds=outds + String.fromCharCode(jlk[code1-20001]);
					}			
					else{
					outds = outds + String.fromCharCode(code1);
					}
	}
	
	Oketa = outds.length;
	if (outds[Oketa-1] == " "){
		outds=outds.substring(0,Oketa-1);
		}

    return outds;			
}
	
function vortaro_modifi() {
	var sw=true;
	var modifita, mod_kubun, mod_sw, mod_ichi, mod_data;
	var mofifita2, mod_kubun2, mod_sw2, mod_ichi2, mod_data2;
	var Ssw="";
	var ersw="";
	var mod_ken=modif_data.length;

	for (var i=0; i<mod_ken; ++i){
		modifita=modif_data[i];
		mod_kubun=modifita[0];
		mod_sw=modifita[1];	
		mod_ichi=modifita[2];
		mod_data=modifita[3];
		ersw="";

		if (mod_ichi==""){mod_ichi=9999999;}
		mod_ichi=mod_ichi * 1;
		if ((mod_ichi<0)||(mod_ichi>(vortaro.length-1))){sw=false;ersw=ersw+"A";}
		if (sw!=false){
			if ((mod_sw =="R")&&(mod_kubun =="M")){kap_vortaro[mod_ichi]=mod_data;sw=true;}	
			if ((mod_sw =="R")&&(mod_kubun =="S")){vortaro[mod_ichi]=mod_data;sw=true;}
			if ((mod_sw =="I")&&(mod_kubun =="S")){
				if (Ssw=="S"){vortaro.splice(mod_ichi, 0, mod_data);sw=true;}
				else{sw=false;ersw=ersw+"B";}
				Ssw=""
			}			
			if ((mod_sw =="I")&&(mod_kubun =="M")){
				if (i==mod_ken-1){sw=false;Ssw="E";ersw=ersw+"C";}
				else{
					modifita2=modif_data[i+1];
					mod_kubun2=modifita2[0];
					mod_sw2=modifita2[1];
					mod_ichi2=modifita2[2];
					if ( (mod_kubun2!="S") || (mod_sw2!="I") || (mod_ichi!=mod_ichi2)){sw=false;Ssw="E";ersw=ersw+"D";}
					else{kap_vortaro.splice(mod_ichi, 0, mod_data);Ssw="S";sw=true;}
				}
			}
		}
		if (sw!=true){alert(ersw + "=" + modifita + "追加修正データに間違いが有ります。問い合わせてください。");
		alert("kubun=" + mod_kubun  + "= 2=" + mod_kubun2);
		alert("sw=" + mod_sw  + "= 2=" + mod_sw2);		
		alert("ichi=" + mod_ichi  + "= 2=" + mod_ichi2);		
		}
	}
    return sw;
}
function kap_kigoo_shori(kkig){

		kkig=kkig+"/";
	var kigoo=kkig.split("/", 5);
	var k_page=kigoo[0];

	var k_pagex=parseInt(k_page);
	var amari=k_pagex % 2;
		k_pagex=(k_pagex + amari) / 2;

	if (amari==0){k_page="R"}else{k_page="L"}
	
		kigoo[0]=k_pagex + k_page;

		kigoo[2]=kigoo[2].replace(/\$/g,kigoo[3]);

	var k_midasi=kigoo[1];
		k_midasi=k_midasi.replace(/\$%/g, "$【%");
		k_midasi=k_midasi.replace(/\$\$/g, "$【%】");

		k_midasi=k_midasi.replace(/\$/g, kigoo[2]);
		kigoo[1]=k_midasi.replace(/\%/g, kigoo[3]);

    return kigoo;
}

